package fit.gja.dao;

import javax.sql.DataSource;
import org.springframework.jdbc.core.JdbcTemplate;

public class UserDao {

    private JdbcTemplate template;

    public void setDataSource(DataSource dataSource) {
        this.template = new JdbcTemplate(dataSource);
    }

    public void createUser(User user) {
        template.update("INSERT INTO user (name, surname, username, password, email, telephone)VALUES(?, ? ?)",
                user.getName(), user.getSurname(), user.getUsername(), user.getPassword(), user.getEmail(), user.getTelephone());
    }

    public User getUser(int id) {
        return template.queryForObject("SELECT * FROM user WHERE id = ?", new Object[]{id}, new UserMapper());
    }

    public void updateUser(User user) {
        template.update("UPDATE user SET name = ?, surname = ?, username = ?, password = ?, email = ?, telephone = ? WHERE user_id = ?",
                user.getName(), user.getSurname(), user.getUsername(), user.getPassword(), user.getEmail(), user.getTelephone(), user.getId());
    }

    public void deleteUser(User user) {
        template.update("DELETE FROM user WHERE user_id = ?", user.getId());
    }

}
