package selenium;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;
import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.firefox.FirefoxDriver;

import static org.junit.Assert.*;

public class FacebookTest {

    WebDriver driver;

    /**
     * Open browser Firefox
     */
    @Before
    public void initBrowser() {
        if (driver == null)
            driver = new FirefoxDriver();
    }

    /**
     * Close browser
     */
    @After
    public void closeDriver() {
        if (driver != null) {
            driver.close();
            driver = null;
        }
    }

    @Test
    public void signlInInline() {
        String page = "https://www.facebook.com";
        // load page Facebook
        driver.get(page);
        // find input element with id "email" and set value
        driver.findElement(By.id("email")).sendKeys("42-fake@email.com");
        // find input element with id "pass" and set value
        driver.findElement(By.id("pass")).sendKeys("123456789");
        // find button and send form
        driver.findElement(By.xpath("//input[@data-testid='royal_login_button']")).click();

        // check redirect
        if (driver.getCurrentUrl().equals(page))
            fail("not redirected");
        else
            assertTrue(true);
    }
}
